000001 IDENTIFICATION DIVISION.
000002 PROGRAM-ID. C18IMFAE.
000003 ENVIRONMENT DIVISION.
000004 CONFIGURATION SECTION.
000005 SOURCE-COMPUTER. RMC.
000006 OBJECT-COMPUTER. RMC.
000007 INPUT-OUTPUT SECTION.
000008     COPY "SISTSELE.CBL".
000009     SELECT AUXIFILE ASSIGN TO RANDOM  AUX-PAT.
000010 DATA DIVISION.
000011 FILE SECTION.
000012 FD  AUXIFILE
000013         RECORD CONTAINS 1 CHARACTERS
000014         LABEL RECORDS ARE STANDARD.
000015 01  AUXI-REC.
000016       05  FILLER PIC X.
000017     COPY "SISTFD.CBL".
000018 77 P18COMSU-E PIC Z(1)9.
000019 77 C18NUMER-E PIC Z(7)9.
000020 77 DESDE    PIC 9(8).
000021 77 HASTA    PIC 9(8).
000022 77 DESDE-E PIC Z(7)9.
000023 77 HASTA-E PIC Z(7)9.
000024 77 CANTI      PIC S9(13).
000025 77 TOTAL      PIC S9(13)V99.
000026 01 LINE001.
000027      04 FILLER          PIC X(6)   VALUE "Fecha:".
000028      04 SL-FECDI-EQ     PIC Z9.
000029      04 FILLER          PIC X      VALUE "/".
000030      04 SL-FECME-EQ     PIC Z9.
000031      04 FILLER          PIC X      VALUE "/".
000032      04 SL-FECAN-EQ     PIC Z9.
000033      04 FILLER          PIC X      VALUE SPACES.
000034      04 SL-C00EMPRE     PIC X(30).
000035      04 FILLER          PIC X      VALUE SPACES.
000036      04 FILLER PIC X(23)  VALUE "RESUMEN DE COMPROBANTES".
000037      04 FILLER          PIC X(2)   VALUE SPACES.
000038      04 FILLER          PIC X(7)   VALUE "Pagina:".
000039      04 SL-CON-PAG      PIC Z(2)9.
000040 01 LINE002.
000041      04 FILLER          PIC X(25)  VALUE SPACES.
000042      04 FILLER          PIC X(65)  VALUE ALL "-".
000043 01 LINE003.
000044      04 FILLER          PIC X(7)   VALUE SPACES.
000045      04 FILLER          PIC X(24)  VALUE "RESUMEN DE COMPROBANTES
000046-     " ".
000047      04 SL-P18COMLE     PIC X(4).
000048      04 FILLER          PIC X      VALUE "-".
000049      04 SL-P18COMSU     PIC Z9.
000050      04 FILLER          PIC X      VALUE SPACES.
000051      04 FILLER          PIC X(9)   VALUE "DESDE EL:".
000052      04 SL-DESDE        PIC Z(8).
000053      04 FILLER          PIC X(3)   VALUE "AL:".
000054      04 SL-HASTA        PIC Z(8).
000055 01 LINE004.
000056      04 FILLER          PIC X(80)   VALUE ALL "-".
000057 01 LINE005.
000058      04 FILLER          PIC X(2)   VALUE SPACES.
000059      04 FILLER          PIC X(5)   VALUE "FECHA".
000060      04 FILLER          PIC X(6)   VALUE SPACES.
000061      04 FILLER          PIC X(11)  VALUE "COMPROBANTE".
000062      04 FILLER          PIC X(6)   VALUE SPACES.
000063      04 FILLER          PIC X(7)   VALUE "CLIENTE".
000064      04 FILLER          PIC X(28)  VALUE SPACES.
000065      04 FILLER          PIC X(7)   VALUE "IMPORTE".
000010 01 LINEREG.
000020      04 FILLER          PIC X(6)   VALUE "@REGLA".
000040      04 FILLER          PIC X(6)   VALUE SPACES.
000050      04 FILLER          PIC X      VALUE "|".
000070      04 FILLER          PIC X(10)  VALUE SPACES.
000080      04 FILLER          PIC X      VALUE "|".
000100      04 FILLER          PIC X(14)  VALUE SPACES.
000110      04 FILLER          PIC X(3)   VALUE "| |".
000130      04 FILLER          PIC X(35)  VALUE SPACES.
000140      04 FILLER          PIC X      VALUE "|".
000160      04 FILLER          PIC X(11)  VALUE SPACES.
000170      04 FILLER          PIC X      VALUE "|".
000066 01 LINE006.
000067      04 FILLER          PIC X(80)   VALUE ALL "-".
000068 01 LINE007.
000069      04 FILLER          PIC X      VALUE SPACES.
000070      04 SL-C18FECDI     PIC Z9.
000071      04 FILLER          PIC X      VALUE "/".
000072      04 SL-C18FECME     PIC Z9.
000073      04 FILLER          PIC X      VALUE "/".
000074      04 SL-C18FECAN     PIC Z(3)9.
000075      04 FILLER          PIC X      VALUE SPACES.
000076      04 SL-C18COMLE     PIC X(4).
000077      04 FILLER          PIC X      VALUE "-".
000078      04 SL-C18COMSU     PIC Z9 .
000079      04 FILLER          PIC X      VALUE "-".
000080      04 SL-C18COMNU     PIC Z(7)9.
000081      04 FILLER          PIC X      VALUE SPACES.
000082      04 SL-C13RAZON     PIC X(31).
000083      04 FILLER          PIC X      VALUE SPACES.
000084      04 SL-C18IMPOR     PIC Z(11)9.9(2).
000085 01 LINE008.
000086      04 FILLER          PIC X(59)  VALUE SPACES.
000087      04 FILLER          PIC X(18)  VALUE "==================".
000088 01 LINE009.
000089      04 FILLER          PIC X(30)  VALUE SPACES.
000090      04 FILLER          PIC X(13)  VALUE "COMPROBANTES".
000091      04 SL-CANTI        PIC Z(10)9.
000092      04 FILLER          PIC X      VALUE SPACES.
000093      04 FILLER          PIC X(6)   VALUE "TOTAL ".
000094      04 SL-TOTAL        PIC Z(11)9.9(2).
000095 COPY "SISTSTAT.CBL".
000096 PROGRAMA.
000097     MOVE 'C18IMFAE' TO PROGRA.
000098     CALL 'USOGRABA' USING USRID SESIO PROGRA.
000099     CANCEL 'USOGRABA'.
000100     MOVE PROGRA TO IMP-PRT
000101     OPEN INPUT C00 C13 C18 TG45.
000102     MOVE 1 TO C00NUMER.
000103     READ C00.
000104     MOVE ZERO TO CON-PAG.
000105     MOVE SPACES TO P18COMPR.
000106     MOVE ZERO TO P18COMSU.
000107     MOVE SPACES TO TG45DESCR
000108     MOVE ZERO TO DESDE.
000109     MOVE ZERO TO HASTA.
000110 PEDIDO.
000111     DISPLAY "ͻ"
000112             LOW LINE 2 POSITION 33.
000113     MOVE 3 TO FILA.
000114 OTRO-CUA.
000115     DISPLAY "                                "
000116             LOW LINE FILA POSITION 33.
000117     ADD 1 TO FILA.
000118     IF FILA < 18 GO TO OTRO-CUA.
000119     DISPLAY "ͼ"
000120             LOW LINE 18 POSITION 33.
000121     DISPLAY "CLIENTES" LOW LINE 5 POSITION 37.
000122     DISPLAY "IMPRESION DE FACTURAS" LOW LINE 6 POSITION 39.
000123     DISPLAY "COMPROBANTE" LOW LINE 8 POSITION 38.
000124     DISPLAY "-" LOW LINE 8 POSITION 54.
000125     DISPLAY "DESDE:" LOW LINE 11 POSITION 44.
000126     DISPLAY "AL:" LOW LINE 12 POSITION 47.
000127     DISPLAY "P" HIGH LINE 14 POSITION 37.
000128     DISPLAY "PROCESO" LOW LINE 14 POSITION 39.
000131     DISPLAY "LEYENDO:" LOW LINE 16 POSITION 42.
000132     DISPLAY C00EMPRE  LOW  LINE 4 POSITION  35.
000133     DISPLAY P18COMLE  HIGH LINE 8 POSITION  50.
000134     MOVE P18COMSU  TO P18COMSU-E.
000135     DISPLAY P18COMSU-E  HIGH  LINE 8 POSITION  55.
000136     DISPLAY TG45DESCR HIGH  LINE 9 POSITION  35.
000137     MOVE C18NUMER  TO C18NUMER-E.
000138     DISPLAY C18NUMER-E  HIGH  LINE 16 POSITION  50.
000139     MOVE DESDE  TO DESDE-E.
000140     DISPLAY DESDE-E  HIGH  LINE 11 POSITION  50.
000141     MOVE HASTA  TO HASTA-E.
000142     DISPLAY HASTA-E  HIGH  LINE 12 POSITION  50.
000143 P18COMPR-ACC.
000144     ACCEPT P18COMLE SIZE  4 PROMPT UPDATE
000145                HIGH  LINE 8 POSITION  50
000146     ACCEPT FUN-COD FROM ESCAPE KEY.
000147     IF FUN-COD = 27 GO TO FINALIZAR.
000148     IF FUN-COD = 01
000149                 DISPLAY SAV-SCR CONTROL CREATE-WINDOW
000150                          LINE 1 POSITION 1
000151                 CALL "TG45POIN" USING
000152                        USRID P18COMLE P18COMSU FUN-COD SESIO
000153                 CANCEL "TG45POIN"
000154                 DISPLAY SAV-SCR CONTROL "WINDOW-REMOVE"
000155                 GO TO P18COMSU-SEG.
000156     PERFORM MENSAJE-DIS .
000157     DISPLAY P18COMLE HIGH LINE 8 POSITION  50.
000158 P18COMSU-ACC.
000159     ACCEPT P18COMSU SIZE  2 PROMPT UPDATE
000160                HIGH  LINE 8 POSITION  55
000161     ACCEPT FUN-COD FROM ESCAPE KEY.
000162     IF FUN-COD = 52 PERFORM MENSAJE-DIS GO TO P18COMPR-ACC.
000163     IF FUN-COD = 27 GO TO FINALIZAR.
000164     IF P18COMSU IS NOT NUMERIC GO TO P18COMSU-ACC.
000165     IF FUN-COD = 01
000166                 DISPLAY SAV-SCR CONTROL CREATE-WINDOW
000167                          LINE 1 POSITION 1
000168                 CALL "TG45POIN" USING
000169                       USRID P18COMLE P18COMSU FUN-COD SESIO
000170                 CANCEL "TG45POIN"
000171                 DISPLAY SAV-SCR CONTROL "WINDOW-REMOVE".
000172 P18COMSU-SEG.
000173     IF FUN-COD = 27 GO TO FINALIZAR.
000174     MOVE P18COMLE TO TG45COMPR
000175     MOVE P18COMSU TO TG45SUCUR
000176     READ TG45 WITH NO LOCK INVALID KEY
000177          DISPLAY SAV-SCR CONTROL CREATE-WINDOW
000178                   LINE 1 POSITION 1
000179          CALL "TG45POIN"
000180          USING USRID P18COMLE P18COMSU FUN-COD SESIO
000181          CANCEL "TG45POIN"
000182          DISPLAY SAV-SCR CONTROL "WINDOW-REMOVE"
000183          GO TO P18COMSU-SEG.
000184     PERFORM MENSAJE-DIS .
000185     DISPLAY P18COMLE  HIGH  LINE 8 POSITION  50.
000186     MOVE P18COMSU  TO P18COMSU-E.
000187     DISPLAY P18COMSU-E  HIGH  LINE 8 POSITION  55.
000188     DISPLAY TG45DESCR HIGH LINE 9 POSITION  35.
000189 DESDE-ACC.
000190     ACCEPT DESDE SIZE  8 PROMPT UPDATE
000191                HIGH  LINE 11 POSITION  50.
000192     ACCEPT FUN-COD FROM ESCAPE KEY.
000193     IF FUN-COD = 27 GO TO FINALIZAR.
000194     IF FUN-COD = 52 PERFORM MENSAJE-DIS GO TO P18COMSU-ACC.
000195     IF DESDE IS NOT NUMERIC GO TO DESDE-ACC.
000196     PERFORM MENSAJE-DIS .
000197     MOVE DESDE TO DESDE-E.
000198     DISPLAY DESDE-E HIGH LINE 11 POSITION  50.
000199 HASTA-ACC.
000200     ACCEPT HASTA SIZE  8 PROMPT UPDATE
000201                HIGH  LINE 12 POSITION  50
000202     ACCEPT FUN-COD FROM ESCAPE KEY.
000203     IF FUN-COD = 27 GO TO FINALIZAR.
000204     IF FUN-COD = 52 PERFORM MENSAJE-DIS GO TO DESDE-ACC.
000205     IF HASTA IS NOT NUMERIC GO TO HASTA-ACC.
000206     PERFORM MENSAJE-DIS .
000207     MOVE HASTA TO HASTA-E.
000208     DISPLAY HASTA-E HIGH LINE 12 POSITION  50.
000209     IF DESDE > HASTA
000210             MOVE  "DESDE MAYOR QUE HASTA REVISE POR FAVOR"
000211             TO MENSAJE PERFORM MENSAJE-DIS GO TO DESDE-ACC.
000212     PERFORM MENSAJE-DIS .
000213 IND-ACC.
000214         ACCEPT IND SIZE  1 PROMPT
000215                HIGH  LINE 14 POSITION  61
000216     ACCEPT FUN-COD FROM ESCAPE KEY.
000217     IF FUN-COD = 27 GO TO FINALIZAR.
000218     IF FUN-COD = 52 PERFORM MENSAJE-DIS GO TO HASTA-ACC.
000220     IF IND = "p" MOVE "P" TO IND.
000221     IF IND = "P" NEXT SENTENCE ELSE GO TO IND-ACC.
      *    IF P18COMSU = 1
      *         PERFORM FACTU-B THRU FIN-FACTU-B
      *                 GO TO FINALIZAR.
000223 ORIGINALES.
000224     MOVE ZERO   TO TOTAL CANTI.
000225     MOVE LOW-VALUES TO C18COMPR-LA
000226     MOVE P18COMLE  TO C18COMLE.
000227     MOVE P18COMSU  TO C18COMSU.
000228     MOVE DESDE     TO C18COMNU.
000229     START C18 KEY IS NOT LESS THAN C18COMPR-LA
000230         INVALID KEY  MOVE "NO HAY DESPUES "
000231             TO MENSAJE PERFORM MENSAJE-DIS GO TO IND-ACC.
000232 OTRO-C18-OR.
000233     READ C18 NEXT RECORD AT END GO TO DUPLICADOS.
000234     MOVE C18NUMER  TO C18NUMER-E.
000235     DISPLAY C18NUMER-E  HIGH  LINE 16 POSITION  50.
000236     IF C18COMSU IS NOT = P18COMSU GO TO DUPLICADOS.
000237     IF C18COMLE IS NOT = P18COMLE GO TO DUPLICADOS.
000238     IF C18COMNU > HASTA GO TO DUPLICADOS.
000239     IF C18COMLE = P18COMLE AND P18COMSU = P18COMSU
000240                   NEXT SENTENCE ELSE  GO TO OTRO-C18-OR.
           CALL "BASIMFAE" USING
                   USRID C18COMLE C18COMSU C18COMNU "P"
000261     GO TO OTRO-C18-OR.
000223 DUPLICADOS.
000224     MOVE ZERO   TO TOTAL CANTI.
000225     MOVE LOW-VALUES TO C18COMPR-LA
000226     MOVE P18COMLE  TO C18COMLE.
000227     MOVE P18COMSU  TO C18COMSU.
000228     MOVE DESDE     TO C18COMNU.
000229     START C18 KEY IS NOT LESS THAN C18COMPR-LA.
000232 OTRO-C18-DU.
000233     READ C18 NEXT RECORD AT END GO TO TOTALES.
000234     MOVE C18NUMER  TO C18NUMER-E.
000235     DISPLAY C18NUMER-E  HIGH  LINE 16 POSITION  50.
000236     IF C18COMSU IS NOT = P18COMSU GO TO TOTALES.
000237     IF C18COMLE IS NOT = P18COMLE GO TO TOTALES.
000238     IF C18COMNU > HASTA GO TO TOTALES.
000239     IF C18COMLE = P18COMLE AND P18COMSU = P18COMSU
000240                      NEXT SENTENCE ELSE  GO TO OTRO-C18-DU.
           CALL "BASIMFAE" USING
                   USRID C18COMLE C18COMSU C18COMNU "S"
000261     GO TO OTRO-C18-DU.
000285 TOTALES.
000285 FINALIZAR.
000286     CLOSE C00 C13 C18 TG45.
000287 SALIDA.
000288     EXIT PROGRAM.
000289 MENSAJE-DIS.
000290     DISPLAY MENSAJE BLINK LINE 24 POSITION 1.
000291     MOVE SPACES TO MENSAJE.


000223 FACTU-B.
000224     MOVE ZERO   TO TOTAL CANTI.
000225     MOVE LOW-VALUES TO C18COMPR-LA
000226     MOVE P18COMLE  TO C18COMLE.
000227     MOVE P18COMSU  TO C18COMSU.
000228     MOVE DESDE     TO C18COMNU.
000229     START C18 KEY IS NOT LESS THAN C18COMPR-LA
000230         INVALID KEY  MOVE "NO HAY DESPUES "
000231             TO MENSAJE PERFORM MENSAJE-DIS GO TO FIN-FACTU-B.
000232 OTRO-C18-FB.
000233     READ C18 NEXT RECORD AT END GO TO FIN-FACTU-B.
000234     MOVE C18NUMER  TO C18NUMER-E.
000235     DISPLAY C18NUMER-E  HIGH  LINE 16 POSITION  50.
000236     IF C18COMSU IS NOT = P18COMSU GO TO FIN-FACTU-B.
000237     IF C18COMLE IS NOT = P18COMLE GO TO FIN-FACTU-B.
000238     IF C18COMNU > HASTA GO TO FIN-FACTU-B.
000239     IF C18COMLE = P18COMLE AND P18COMSU = P18COMSU
000240                   NEXT SENTENCE ELSE  GO TO OTRO-C18-FB.
           CALL "C18REIMP" USING
                   USRID C18COMLE C18COMSU C18COMNU "P"
000261     GO TO OTRO-C18-FB.
000223 FIN-FACTU-B.
